This sample shows regular column, related column and calculated column, you can create different types of TableSheet columns in SpreadJS.
Regular column
Just use the data field name as column value, such as "firstName" in the employee table.
If the field value is an object, can use the "." to get the sub-field, such as "address.city" in the employee table.
Related column
After add relationship between two tables, user can use the related table as a field. Here is the sample code:
If the fields is an array, can use the ".1" to get the first item, e.g. "orders.1.orderDate". And use the ".property" to get the property form every object and get a new array, e.g. "orders.orderDate".
Calculated column
You can set the column value with a formula start with "=" as calculated column. With the field reference syntax rules in the following, you can reference the data in the table.
Object Type
Syntax Examples
Explain
Sample
Current Row Field
=[@column1]
get the data in the corrent row of field column1
=[@QtyAvailable] * [@UnitPrice] * 1.5
calculate the RetailValue of each row
Whole field
=[column1]
get all the data in the column1
=SUM([column1])
get the total sum of column1.
Attribute of Object Field
=[@column1.abc]
get the attribute value of "abc" in the current row of field column1
=[@name.first] & " " & [@name.last]
get the name string
Item of Array Field
=[@column1.0]
get the first value in the corrent row of field column1
=[@awards.0.name]
get the first award name
Attribute of Object Array Field
=[@column1.abc]
worksheet
=SUM([@orderDetails.weight])
get the weight of the order.
Current Whole Row
=[@]
Get the current row data as an object.
If the field name have space or dot, user should add the square brackets, such as: "=[@[column 1].[a.bc]]" will get the attribute value of "a.bc" in the current row of field 'column 1'
Besides the whole row and current row, user can get the specified row:
Sample
Explain
[#1[column1]]
get column1 value in first row.
[#1,#last[column1]]
get column1 values in first and last rows
[#odd[column1]]
get the column1 values in odd rows.
[#1,#even[column1]]
get the column1 values in first row and even rows.
[@+1[column1]]
get column1 value in the next row
[@-1[column1]]
get column1 value in the previous row.
[@+1:#last]
get the rows from next to the last row
[@-1:@+1]
get the rows from previous row to the next row
[@:#last]
get the rows from current row to the last row
[#1,@-1:@+1,#last[column1]]
get column1 values in first row, previous row to the next row, and the last row.
[#1]
get first row.
Here is the sample:
"=SUM([#1:@[change]])" will show the cumulative change.
var tables = {};
var selectedTable = "order";
window.onload = function () {
var mainSpread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
var dataManager = mainSpread.dataManager();
// addTable
tables.product = dataManager.addTable("productTable", {
data: data.products
});
tables.supplier = dataManager.addTable("supplierTable", {
data: data.suppliers
});
tables.category = dataManager.addTable("categoryTable", {
data: data.categories
});
tables.order = dataManager.addTable("orderTable", {
data: data.orders
});
tables.detail = dataManager.addTable("orderDetailTable", {
data: data.orderDetails
});
tables.shipper = dataManager.addTable("shipperTable", {
data: data.shippers
});
tables.employee = dataManager.addTable("employeeTable", {
data: data.employees
});
tables.customer = dataManager.addTable("customerTable", {
data: data.customers
});
// addRelationship
dataManager.addRelationship(tables.product, "supplierId", "supplier", tables.supplier, "id", "products");
dataManager.addRelationship(tables.product, "categoryId", "category", tables.category, "id", "products");
dataManager.addRelationship(tables.order, "customerId", "customer", tables.customer, "id", "orders");
dataManager.addRelationship(tables.order, "shipVia", "shipper", tables.shipper, "id", "orders");
dataManager.addRelationship(tables.order, "id", "details", tables.detail, "orderId", "order");
dataManager.addRelationship(tables.order, "employeeId", "employee", tables.employee, "id", "orders");
dataManager.addRelationship(tables.product, "id", "soldDetail", tables.detail, "productId", "product");
dataManager.addRelationship(tables.employee, "reportsTo", "manager", tables.employee, "id", "subordinate");
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("sampleDiv2"));
spread.fromJSON(ssjson);
spread.options.scrollbarMaxAlign = true;
var columnsSpread = new GC.Spread.Sheets.Workbook(document.getElementById("sampleDiv3"));
var sheet = columnsSpread.getActiveSheet();
columnsSpread.options.tabStripVisible = false;
columnsSpread.options.showHorizontalScrollbar = false;
columnsSpread.options.scrollbarMaxAlign = true;
sheet.setColumnCount(2);
sheet.setRowCount(12);
sheet.setColumnWidth(1, "*");
sheet.setText(0,0,"Caption",1);
sheet.setText(0,1,"Value",1);
sheet.getRange(-1,1,-1,1).formatter("@");
document.getElementById("sampleDiv2").addEventListener("click", function (e) {
var x = e.offsetX;
var y = e.offsetY;
var target = spread.getActiveSheet().hitTest(x, y);
if (target.shapeHitInfo == null && x > 700) {
y = y - 300;
target = spread.getActiveSheet().hitTest(x, y);
}
if (target.shapeHitInfo) {
var shape = target.shapeHitInfo.shape;
var style = shape.style();
if (style.fill) { // skip the connect line
style.fill.color = '#'+Math.floor(Math.random()*0xA00000 + 0x100000).toString(16); //random color
shape.style(style);
var text = shape.text();
switchTable(text);
}
}
}, false);
document.getElementById("setButton").addEventListener("click", function (e) {
setView();
}, false);
switchTable("order");
};
function switchTable (tableName) {
selectedTable = tableName;
setTimeout(function() {
var json = JSON.stringify(tables[selectedTable].get(0),null , 2); // get is internal API
document.getElementById("datasample").innerHTML = selectedTable + ".0:\n" + json;
}, 0);
var spread = GC.Spread.Sheets.findControl( document.getElementById("sampleDiv3"));
var sheet = spread.getActiveSheet();
sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport,GC.Spread.Sheets.StorageType.data);
sheet.setArray(0,0,dataColumns[tableName]);
sheet.autoFitColumn(0);
setView();
}
function setView () {
var spread = GC.Spread.Sheets.findControl( document.getElementById("sampleDiv3"));
var sheet = spread.getActiveSheet();
var rowCount = sheet.getRowCount();
var fields = [];
for (var i = 0; i < rowCount; i++) {
var value = sheet.getValue(i, 1);
if (value) {
fields.push({value: value, caption: sheet.getValue(i, 0), width: 200});
}
}
var view = tables[selectedTable].addView("selectedTable"+(new Date()).valueOf(), fields);
var spread = GC.Spread.Sheets.findControl( document.getElementById("ss"));
spread.clearSheets();
spread.clearSheetTabs();
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false;
sheet.actionColumn.options({ visible: false });
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
view.fetch().then(function(args) {
sheet.suspendPaint();
sheet.setDataView(view);
sheet.resumePaint();
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill -->
<script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/northwind-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/temple-shape.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<div class="inputContainer">
<p>You can click the table.</p>
<div id="sampleDiv2" style="height: 143px;"></div>
</div>
<div class="inputContainer">
<p>You can edit the columns then press the "Set" button.</p>
<div id="sampleDiv3" style="height: 200px;"></div>
<div class="col-xs-4">
<input id="setButton" class="button" type="button" value="Set"/>
</div>
</div>
<div class="inputContainer">
<p>First data in the data table</p>
<pre id="datasample">
</pre>
</div>
</div>
</div>
</div>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 500px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 500px;
padding: 3px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px 12px;
margin-bottom: 10px;
box-sizing: border-box;
}
.input {
font-size: 14px;
border: 0;
outline: none;
background: transparent;
}
.button {
height: 30px;
padding: 6px 6px;
width: 80px;
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

This sample shows regular column, related column and calculated column, you can create different types of TableSheet columns in SpreadJS.
Regular column
Just use the data field name as column value, such as "firstName" in the employee table.
If the field value is an object, can use the "." to get the sub-field, such as "address.city" in the employee table.
Related column
After add relationship between two tables, user can use the related table as a field. Here is the sample code:
If the fields is an array, can use the ".1" to get the first item, e.g. "orders.1.orderDate". And use the ".property" to get the property form every object and get a new array, e.g. "orders.orderDate".
Calculated column
You can set the column value with a formula start with "=" as calculated column. With the field reference syntax rules in the following, you can reference the data in the table.
Object Type
Syntax Examples
Explain
Sample
Current Row Field
=[@column1]
get the data in the corrent row of field column1
=[@QtyAvailable] * [@UnitPrice] * 1.5
calculate the RetailValue of each row
Whole field
=[column1]
get all the data in the column1
=SUM([column1])
get the total sum of column1.
Attribute of Object Field
=[@column1.abc]
get the attribute value of "abc" in the current row of field column1
=[@name.first] & " " & [@name.last]
get the name string
Item of Array Field
=[@column1.0]
get the first value in the corrent row of field column1
=[@awards.0.name]
get the first award name
Attribute of Object Array Field
=[@column1.abc]
worksheet
=SUM([@orderDetails.weight])
get the weight of the order.
Current Whole Row
=[@]
Get the current row data as an object.
If the field name have space or dot, user should add the square brackets, such as: "=[@[column 1].[a.bc]]" will get the attribute value of "a.bc" in the current row of field 'column 1'
Besides the whole row and current row, user can get the specified row:
Sample
Explain
[#1[column1]]
get column1 value in first row.
[#1,#last[column1]]
get column1 values in first and last rows
[#odd[column1]]
get the column1 values in odd rows.
[#1,#even[column1]]
get the column1 values in first row and even rows.
[@+1[column1]]
get column1 value in the next row
[@-1[column1]]
get column1 value in the previous row.
[@+1:#last]
get the rows from next to the last row
[@-1:@+1]
get the rows from previous row to the next row
[@:#last]
get the rows from current row to the last row
[#1,@-1:@+1,#last[column1]]
get column1 values in first row, previous row to the next row, and the last row.
[#1]
get first row.
Here is the sample:
"=SUM([#1:@[change]])" will show the cumulative change.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<div class="inputContainer">
<p>You can click the table.</p>
<div @click="clickShape($event)">
<gc-spread-sheets style="height: 143px;" @workbookInitialized="initSpread2">
</gc-spread-sheets>
</div>
</div>
<div class="inputContainer">
<p>You can edit the columns then press the "Set" button.</p>
<gc-spread-sheets style="height: 200px;" @workbookInitialized="initSpread3">
</gc-spread-sheets>
<div class="col-xs-4">
<input id="setButton" class="button" type="button" value="Set" @click="setView" />
</div>
</div>
<div class="inputContainer">
<p>First data in the data table</p>
<pre id="datasample"></pre>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref, toRaw } from "vue";
import '@mescius/spread-sheets-shapes';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-vue";
const spread1 = ref(null);
const spread2 = ref(null);
const spread3 = ref(null);
const tablesRef = ref({});
const selectTable = ref(null);
const initSpread = (spread) => {
spread1.value = spread;
}
const initSpread2 = (spread) => {
spread2.value = spread;
spread.fromJSON(ssjson);
spread.options.scrollbarMaxAlign = true;
}
const initSpread3 = (columnsSpread) => {
spread3.value = columnsSpread;
let dataManager = spread1.value.dataManager();
// addTable
let tables = tablesRef.value;
tables.product = dataManager.addTable("productTable", {
data: data.products
});
tables.supplier = dataManager.addTable("supplierTable", {
data: data.suppliers
});
tables.category = dataManager.addTable("categoryTable", {
data: data.categories
});
tables.order = dataManager.addTable("orderTable", {
data: data.orders
});
tables.detail = dataManager.addTable("orderDetailTable", {
data: data.orderDetails
});
tables.shipper = dataManager.addTable("shipperTable", {
data: data.shippers
});
tables.employee = dataManager.addTable("employeeTable", {
data: data.employees
});
tables.customer = dataManager.addTable("customerTable", {
data: data.customers
});
// addRelationship
dataManager.addRelationship(tables.product, "supplierId", "supplier", tables.supplier, "id", "products");
dataManager.addRelationship(tables.product, "categoryId", "category", tables.category, "id", "products");
dataManager.addRelationship(tables.order, "customerId", "customer", tables.customer, "id", "orders");
dataManager.addRelationship(tables.order, "shipVia", "shipper", tables.shipper, "id", "orders");
dataManager.addRelationship(tables.order, "id", "details", tables.detail, "orderId", "order");
dataManager.addRelationship(tables.order, "employeeId", "employee", tables.employee, "id", "orders");
dataManager.addRelationship(tables.product, "id", "soldDetail", tables.detail, "productId", "product");
dataManager.addRelationship(tables.employee, "reportsTo", "manager", tables.employee, "id", "subordinate");
var sheet = columnsSpread.getActiveSheet();
columnsSpread.options.tabStripVisible = false;
columnsSpread.options.showHorizontalScrollbar = false;
columnsSpread.options.scrollbarMaxAlign = true;
sheet.setColumnCount(2);
sheet.setRowCount(12);
sheet.setColumnWidth(1, "*");
sheet.setText(0, 0, "Caption", 1);
sheet.setText(0, 1, "Value", 1);
sheet.getRange(-1, 1, -1, 1).formatter("@");
setTimeout(() => {
switchTable("order");
})
}
const clickShape = ($event) => {
var x = $event.offsetX;
var y = $event.offsetY;
let spread = spread2.value;
var target = spread.getActiveSheet().hitTest(x, y);
if (target.shapeHitInfo == null && x > 700) {
y = y - 300;
target = spread.getActiveSheet().hitTest(x, y);
}
if (target.shapeHitInfo) {
var shape = target.shapeHitInfo.shape;
var style = shape.style();
if (style.fill) { // skip the connect line
style.fill.color = '#' + Math.floor(Math.random() * 0xA00000 + 0x100000).toString(16); //random color
shape.style(style);
var text = shape.text();
switchTable(text);
}
}
}
const switchTable = (tableName) => {
selectTable.value = tableName;
setTimeout(function () {
var json = JSON.stringify(tablesRef.value[selectTable.value].get(0), null, 2); // get is internal API
document.getElementById("datasample").innerHTML = selectTable.value + ".0:\n" + json;
}, 0);
var spread = spread3.value;
var sheet = spread.getActiveSheet();
sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport, GC.Spread.Sheets.StorageType.data);
sheet.setArray(0, 0, dataColumns[tableName]);
sheet.autoFitColumn(0);
setView();
}
const setView = () => {
var spread = spread3.value;
var sheet = spread.getActiveSheet();
var rowCount = sheet.getRowCount();
var fields = [];
for (var i = 0; i < rowCount; i++) {
var value = sheet.getValue(i, 1);
if (value) {
fields.push({ value: value, caption: sheet.getValue(i, 0), width: "*" });
}
}
var view = tablesRef.value[selectTable.value].addView("selectedTable" + (new Date()).valueOf(), fields);
var mainSpread = toRaw(spread1.value);
mainSpread.clearSheets();
mainSpread.clearSheetTabs();
var sheet = mainSpread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false;
sheet.actionColumn.options({ visible: false });
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
mainSpread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
view.fetch().then(function (args) {
sheet.suspendPaint();
sheet.setDataView(view);
sheet.resumePaint();
});
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 500px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 500px;
padding: 3px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px 12px;
margin-bottom: 10px;
box-sizing: border-box;
}
.input {
font-size: 14px;
border: 0;
outline: none;
background: transparent;
}
.button {
height: 30px;
padding: 6px 6px;
width: 80px;
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=edge"/>
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0"/>
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/northwind-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/temple-shape.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

This sample shows regular column, related column and calculated column, you can create different types of TableSheet columns in SpreadJS.
Regular column
Just use the data field name as column value, such as "firstName" in the employee table.
If the field value is an object, can use the "." to get the sub-field, such as "address.city" in the employee table.
Related column
After add relationship between two tables, user can use the related table as a field. Here is the sample code:
If the fields is an array, can use the ".1" to get the first item, e.g. "orders.1.orderDate". And use the ".property" to get the property form every object and get a new array, e.g. "orders.orderDate".
Calculated column
You can set the column value with a formula start with "=" as calculated column. With the field reference syntax rules in the following, you can reference the data in the table.
Object Type
Syntax Examples
Explain
Sample
Current Row Field
=[@column1]
get the data in the corrent row of field column1
=[@QtyAvailable] * [@UnitPrice] * 1.5
calculate the RetailValue of each row
Whole field
=[column1]
get all the data in the column1
=SUM([column1])
get the total sum of column1.
Attribute of Object Field
=[@column1.abc]
get the attribute value of "abc" in the current row of field column1
=[@name.first] & " " & [@name.last]
get the name string
Item of Array Field
=[@column1.0]
get the first value in the corrent row of field column1
=[@awards.0.name]
get the first award name
Attribute of Object Array Field
=[@column1.abc]
worksheet
=SUM([@orderDetails.weight])
get the weight of the order.
Current Whole Row
=[@]
Get the current row data as an object.
If the field name have space or dot, user should add the square brackets, such as: "=[@[column 1].[a.bc]]" will get the attribute value of "a.bc" in the current row of field 'column 1'
Besides the whole row and current row, user can get the specified row:
Sample
Explain
[#1[column1]]
get column1 value in first row.
[#1,#last[column1]]
get column1 values in first and last rows
[#odd[column1]]
get the column1 values in odd rows.
[#1,#even[column1]]
get the column1 values in first row and even rows.
[@+1[column1]]
get column1 value in the next row
[@-1[column1]]
get column1 value in the previous row.
[@+1:#last]
get the rows from next to the last row
[@-1:@+1]
get the rows from previous row to the next row
[@:#last]
get the rows from current row to the last row
[#1,@-1:@+1,#last[column1]]
get column1 values in first row, previous row to the next row, and the last row.
[#1]
get first row.
Here is the sample:
"=SUM([#1:@[change]])" will show the cumulative change.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-shapes';
import "@mescius/spread-sheets-tablesheet";
import './styles.css';
declare var saveAs: any;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 500px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
hostStyle1 = {
height: '143px'
};
hostStyle2 = {
height: '200px'
};
spread: GC.Spread.Sheets.Workbook;
spread2: GC.Spread.Sheets.Workbook;
spread3: GC.Spread.Sheets.Workbook;
selectedTable: string;
tables: any;
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
}
initSpread2($event: any) {
let spread = this.spread2 = $event.spread;
spread.fromJSON(ssjson);
spread.options.scrollbarMaxAlign = true;
}
initSpread3($event: any) {
var dataManager = this.spread.dataManager();
// addTable
this.tables = {};
this.tables.product = dataManager.addTable("productTable", {
data: data.products
});
this.tables.supplier = dataManager.addTable("supplierTable", {
data: data.suppliers
});
this.tables.category = dataManager.addTable("categoryTable", {
data: data.categories
});
this.tables.order = dataManager.addTable("orderTable", {
data: data.orders
});
this.tables.detail = dataManager.addTable("orderDetailTable", {
data: data.orderDetails
});
this.tables.shipper = dataManager.addTable("shipperTable", {
data: data.shippers
});
this.tables.employee = dataManager.addTable("employeeTable", {
data: data.employees
});
this.tables.customer = dataManager.addTable("customerTable", {
data: data.customers
});
// addRelationship
dataManager.addRelationship(this.tables.product, "supplierId", "supplier", this.tables.supplier, "id", "products");
dataManager.addRelationship(this.tables.product, "categoryId", "category", this.tables.category, "id", "products");
dataManager.addRelationship(this.tables.order, "customerId", "customer", this.tables.customer, "id", "orders");
dataManager.addRelationship(this.tables.order, "shipVia", "shipper", this.tables.shipper, "id", "orders");
dataManager.addRelationship(this.tables.order, "id", "details", this.tables.detail, "orderId", "order");
dataManager.addRelationship(this.tables.order, "employeeId", "employee", this.tables.employee, "id", "orders");
dataManager.addRelationship(this.tables.product, "id", "soldDetail", this.tables.detail, "productId", "product");
dataManager.addRelationship(this.tables.employee, "reportsTo", "manager", this.tables.employee, "id", "subordinate");
let columnsSpread = this.spread3 = $event.spread;
var sheet = columnsSpread.getActiveSheet();
columnsSpread.options.tabStripVisible = false;
columnsSpread.options.showHorizontalScrollbar = false;
columnsSpread.options.scrollbarMaxAlign = true;
sheet.setColumnCount(2);
sheet.setRowCount(12);
sheet.setColumnWidth(1, "*");
sheet.setText(0,0,"Caption",1);
sheet.setText(0,1,"Value",1);
sheet.getRange(-1,1,-1,1).formatter("@");
setTimeout(()=>{
this.switchTable("order");
})
}
clickShape ($event: any) {
var x = $event.offsetX;
var y = $event.offsetY;
var target = this.spread2.getActiveSheet().hitTest(x, y);
if (target.shapeHitInfo == null && x > 700) {
y = y - 300;
target = this.spread2.getActiveSheet().hitTest(x, y);
}
if (target.shapeHitInfo) {
var shape = target.shapeHitInfo.shape;
var style = shape.style();
if (style.fill) { // skip the connect line
style.fill.color = '#'+Math.floor(Math.random()*0xA00000 + 0x100000).toString(16); //random color
shape.style(style);
var text = shape.text();
this.switchTable(text);
}
}
}
switchTable (tableName: string) {
var self = this;
self.selectedTable = tableName;
setTimeout(function() {
var json = JSON.stringify(self.tables[self.selectedTable].get(0),null , 2); // get is internal API
document.getElementById("datasample").innerHTML = self.selectedTable + ".0:\n" + json;
}, 0);
var spread = self.spread3;
var sheet = spread.getActiveSheet();
sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport,GC.Spread.Sheets.StorageType.data);
sheet.setArray(0, 0, dataColumns[tableName]);
sheet.autoFitColumn(0);
self.setView();
}
setView () {
var spread = this.spread3;
var sheet = spread.getActiveSheet();
var rowCount = sheet.getRowCount();
var fields = [];
for (var i = 0; i < rowCount; i++) {
var value = sheet.getValue(i, 1);
if (value) {
fields.push({value: value, caption: sheet.getValue(i, 0), width: "*"});
}
}
var view = this.tables[this.selectedTable].addView("selectedTable"+(new Date()).valueOf(), fields);
var mainSpread = this.spread;
mainSpread.clearSheets();
mainSpread.clearSheetTabs();
var sheet = mainSpread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false;
sheet.actionColumn.options({ visible: false });
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
mainSpread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
view.fetch().then(function(args) {
sheet.suspendPaint();
sheet.setDataView(view);
sheet.resumePaint();
});
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/northwind-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/temple-shape.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<div class="inputContainer">
<p>You can click the table.</p>
<gc-spread-sheets [hostStyle]="hostStyle1" (workbookInitialized)="initSpread2($event)" (click)="clickShape($event)">
</gc-spread-sheets>
</div>
<div class="inputContainer">
<p>You can edit the columns then press the "Set" button.</p>
<gc-spread-sheets [hostStyle]="hostStyle2" (workbookInitialized)="initSpread3($event)">
</gc-spread-sheets>
<div class="col-xs-4">
<input id="setButton" class="button" type="button" value="Set" (click)="setView()"/>
</div>
</div>
<div class="inputContainer">
<p>First data in the data table</p>
<pre id="datasample">
</pre>
</div>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 500px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 500px;
padding: 3px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px 12px;
margin-bottom: 10px;
box-sizing: border-box;
}
.input {
font-size: 14px;
border: 0;
outline: none;
background: transparent;
}
.button {
height: 30px;
padding: 6px 6px;
width: 80px;
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

This sample shows regular column, related column and calculated column, you can create different types of TableSheet columns in SpreadJS.
Regular column
Just use the data field name as column value, such as "firstName" in the employee table.
If the field value is an object, can use the "." to get the sub-field, such as "address.city" in the employee table.
Related column
After add relationship between two tables, user can use the related table as a field. Here is the sample code:
If the fields is an array, can use the ".1" to get the first item, e.g. "orders.1.orderDate". And use the ".property" to get the property form every object and get a new array, e.g. "orders.orderDate".
Calculated column
You can set the column value with a formula start with "=" as calculated column. With the field reference syntax rules in the following, you can reference the data in the table.
Object Type
Syntax Examples
Explain
Sample
Current Row Field
=[@column1]
get the data in the corrent row of field column1
=[@QtyAvailable] * [@UnitPrice] * 1.5
calculate the RetailValue of each row
Whole field
=[column1]
get all the data in the column1
=SUM([column1])
get the total sum of column1.
Attribute of Object Field
=[@column1.abc]
get the attribute value of "abc" in the current row of field column1
=[@name.first] & " " & [@name.last]
get the name string
Item of Array Field
=[@column1.0]
get the first value in the corrent row of field column1
=[@awards.0.name]
get the first award name
Attribute of Object Array Field
=[@column1.abc]
worksheet
=SUM([@orderDetails.weight])
get the weight of the order.
Current Whole Row
=[@]
Get the current row data as an object.
If the field name have space or dot, user should add the square brackets, such as: "=[@[column 1].[a.bc]]" will get the attribute value of "a.bc" in the current row of field 'column 1'
Besides the whole row and current row, user can get the specified row:
Sample
Explain
[#1[column1]]
get column1 value in first row.
[#1,#last[column1]]
get column1 values in first and last rows
[#odd[column1]]
get the column1 values in odd rows.
[#1,#even[column1]]
get the column1 values in first row and even rows.
[@+1[column1]]
get column1 value in the next row
[@-1[column1]]
get column1 value in the previous row.
[@+1:#last]
get the rows from next to the last row
[@-1:@+1]
get the rows from previous row to the next row
[@:#last]
get the rows from current row to the last row
[#1,@-1:@+1,#last[column1]]
get column1 values in first row, previous row to the next row, and the last row.
[#1]
get first row.
Here is the sample:
"=SUM([#1:@[change]])" will show the cumulative change.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
export function AppFunc() {
let spread1 = null;
let spread2 = null;
let spread3 = null;
let selectedTable = null;
let tables = null;
const initSpread = (spread) => {
spread1 = spread;
}
const initSpread2 = (spread) => {
spread2 = spread;
spread.fromJSON(ssjson);
spread.options.scrollbarMaxAlign = true;
}
const initSpread3 = (columnsSpread) => {
var dataManager = spread1.dataManager();
// addTable
tables = {};
tables.product = dataManager.addTable("productTable", {
data: data.products
});
tables.supplier = dataManager.addTable("supplierTable", {
data: data.suppliers
});
tables.category = dataManager.addTable("categoryTable", {
data: data.categories
});
tables.order = dataManager.addTable("orderTable", {
data: data.orders
});
tables.detail = dataManager.addTable("orderDetailTable", {
data: data.orderDetails
});
tables.shipper = dataManager.addTable("shipperTable", {
data: data.shippers
});
tables.employee = dataManager.addTable("employeeTable", {
data: data.employees
});
tables.customer = dataManager.addTable("customerTable", {
data: data.customers
});
// addRelationship
dataManager.addRelationship(tables.product, "supplierId", "supplier", tables.supplier, "id", "products");
dataManager.addRelationship(tables.product, "categoryId", "category", tables.category, "id", "products");
dataManager.addRelationship(tables.order, "customerId", "customer", tables.customer, "id", "orders");
dataManager.addRelationship(tables.order, "shipVia", "shipper", tables.shipper, "id", "orders");
dataManager.addRelationship(tables.order, "id", "details", tables.detail, "orderId", "order");
dataManager.addRelationship(tables.order, "employeeId", "employee", tables.employee, "id", "orders");
dataManager.addRelationship(tables.product, "id", "soldDetail", tables.detail, "productId", "product");
dataManager.addRelationship(tables.employee, "reportsTo", "manager", tables.employee, "id", "subordinate");
spread3 = columnsSpread;
var sheet = columnsSpread.getActiveSheet();
columnsSpread.options.tabStripVisible = false;
columnsSpread.options.showHorizontalScrollbar = false;
columnsSpread.options.scrollbarMaxAlign = true;
sheet.setColumnCount(2);
sheet.setRowCount(12);
sheet.setColumnWidth(1, "*");
sheet.setText(0,0,"Caption",1);
sheet.setText(0,1,"Value",1);
sheet.getRange(-1,1,-1,1).formatter("@");
setTimeout(()=>{
switchTable("order");
})
}
const clickShape = (e) => {
var sp = spread2.getHost();
//return;
var x = e.pageX - sp.offsetLeft;
var y = e.pageY - sp.offsetTop;
var target = spread2.getActiveSheet().hitTest(x, y);
if (target.shapeHitInfo == null && x > 700) {
y = y - 300;
target = spread2.getActiveSheet().hitTest(x, y);
}
if (target.shapeHitInfo) {
var shape = target.shapeHitInfo.shape;
var style = shape.style();
if (style.fill) { // skip the connect line
style.fill.color = '#'+Math.floor(Math.random()*0xA00000 + 0x100000).toString(16); //random color
shape.style(style);
var text = shape.text();
switchTable(text);
}
}
}
const switchTable = (tableName) => {
selectedTable = tableName;
setTimeout(function() {
var json = JSON.stringify(tables[selectedTable].get(0),null , 2); // get is internal API
document.getElementById("datasample").innerHTML = selectedTable + ".0:\n" + json;
}, 0);
var sheet = spread3.getActiveSheet();
sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport,GC.Spread.Sheets.StorageType.data);
sheet.setArray(0, 0, dataColumns[tableName]);
sheet.autoFitColumn(0);
setView();
}
const setView = () => {
var sheet = spread3.getActiveSheet();
var rowCount = sheet.getRowCount();
var fields = [];
for (var i = 0; i < rowCount; i++) {
var value = sheet.getValue(i, 1);
if (value) {
fields.push({value: value, caption: sheet.getValue(i, 0), width: "*"});
}
}
var view = tables[selectedTable].addView("selectedTable"+(new Date()).valueOf(), fields);
var mainSpread = spread1;
mainSpread.clearSheets();
mainSpread.clearSheetTabs();
var sheet = mainSpread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false;
sheet.actionColumn.options({ visible: false });
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
mainSpread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
view.fetch().then(function(args) {
sheet.suspendPaint();
sheet.setDataView(view);
sheet.resumePaint();
});
}
return (
<div className="sample-tutorial">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
</SpreadSheets>
</div>
<div className="options-container">
<div className="option-row">
<div className="inputContainer">
<p>You can click the table.</p>
<div style={{ height: '143px' }} onClick={clickShape}>
<SpreadSheets workbookInitialized={initSpread2}>
</SpreadSheets>
</div>
</div>
<div className="inputContainer">
<p>You can edit the columns then press the "Set" button.</p>
<SpreadSheets style={{ height: '200px' }} workbookInitialized={initSpread3}>
</SpreadSheets>
<div className="col-xs-4">
<input id="setButton" className="button" type="button" defaultValue="Set" onClick={setView} />
</div>
</div>
<div className="inputContainer">
<p>First data in the data table</p>
<pre id="datasample">{""}</pre>
</div>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.spread2 = null;
this.spread3 = null;
this.selectedTable = null;
this.tables = null;
}
render() {
return (
<div className="sample-tutorial">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div className="options-container">
<div className="option-row">
<div className="inputContainer">
<p>You can click the table.</p>
<div style={{ height: '143px' }} onClick={(e) => this.clickShape(e)}>
<SpreadSheets workbookInitialized={spread => this.initSpread2(spread)}>
</SpreadSheets>
</div>
</div>
<div className="inputContainer">
<p>You can edit the columns then press the "Set" button.</p>
<SpreadSheets style={{ height: '200px' }} workbookInitialized={spread => this.initSpread3(spread)}>
</SpreadSheets>
<div className="col-xs-4">
<input id="setButton" className="button" type="button" defaultValue="Set" onClick={(e) => this.setView(e)} />
</div>
</div>
<div className="inputContainer">
<p>First data in the data table</p>
<pre id="datasample">{""}</pre>
</div>
</div>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
}
initSpread2(spread) {
this.spread2 = spread;
spread.fromJSON(ssjson);
spread.options.scrollbarMaxAlign = true;
}
initSpread3(columnsSpread) {
var dataManager = this.spread.dataManager();
// addTable
this.tables = {};
this.tables.product = dataManager.addTable("productTable", {
data: data.products
});
this.tables.supplier = dataManager.addTable("supplierTable", {
data: data.suppliers
});
this.tables.category = dataManager.addTable("categoryTable", {
data: data.categories
});
this.tables.order = dataManager.addTable("orderTable", {
data: data.orders
});
this.tables.detail = dataManager.addTable("orderDetailTable", {
data: data.orderDetails
});
this.tables.shipper = dataManager.addTable("shipperTable", {
data: data.shippers
});
this.tables.employee = dataManager.addTable("employeeTable", {
data: data.employees
});
this.tables.customer = dataManager.addTable("customerTable", {
data: data.customers
});
// addRelationship
dataManager.addRelationship(this.tables.product, "supplierId", "supplier", this.tables.supplier, "id", "products");
dataManager.addRelationship(this.tables.product, "categoryId", "category", this.tables.category, "id", "products");
dataManager.addRelationship(this.tables.order, "customerId", "customer", this.tables.customer, "id", "orders");
dataManager.addRelationship(this.tables.order, "shipVia", "shipper", this.tables.shipper, "id", "orders");
dataManager.addRelationship(this.tables.order, "id", "details", this.tables.detail, "orderId", "order");
dataManager.addRelationship(this.tables.order, "employeeId", "employee", this.tables.employee, "id", "orders");
dataManager.addRelationship(this.tables.product, "id", "soldDetail", this.tables.detail, "productId", "product");
dataManager.addRelationship(this.tables.employee, "reportsTo", "manager", this.tables.employee, "id", "subordinate");
this.spread3 = columnsSpread;
var sheet = columnsSpread.getActiveSheet();
columnsSpread.options.tabStripVisible = false;
columnsSpread.options.showHorizontalScrollbar = false;
columnsSpread.options.scrollbarMaxAlign = true;
sheet.setColumnCount(2);
sheet.setRowCount(12);
sheet.setColumnWidth(1, "*");
sheet.setText(0,0,"Caption",1);
sheet.setText(0,1,"Value",1);
sheet.getRange(-1,1,-1,1).formatter("@");
setTimeout(()=>{
this.switchTable("order");
})
}
clickShape (e) {
var sp = this.spread2.getHost();
//return;
var x = e.pageX - sp.offsetLeft;
var y = e.pageY - sp.offsetTop;
var target = this.spread2.getActiveSheet().hitTest(x, y);
if (target.shapeHitInfo == null && x > 700) {
y = y - 300;
target = this.spread2.getActiveSheet().hitTest(x, y);
}
if (target.shapeHitInfo) {
var shape = target.shapeHitInfo.shape;
var style = shape.style();
if (style.fill) { // skip the connect line
style.fill.color = '#'+Math.floor(Math.random()*0xA00000 + 0x100000).toString(16); //random color
shape.style(style);
var text = shape.text();
this.switchTable(text);
}
}
}
switchTable (tableName) {
var self = this;
self.selectedTable = tableName;
setTimeout(function() {
var json = JSON.stringify(self.tables[self.selectedTable].get(0),null , 2); // get is internal API
document.getElementById("datasample").innerHTML = self.selectedTable + ".0:\n" + json;
}, 0);
var spread = self.spread3;
var sheet = spread.getActiveSheet();
sheet.clear(0, 0, sheet.getRowCount(), sheet.getColumnCount(), GC.Spread.Sheets.SheetArea.viewport,GC.Spread.Sheets.StorageType.data);
sheet.setArray(0, 0, dataColumns[tableName]);
sheet.autoFitColumn(0);
self.setView();
}
setView () {
var spread = this.spread3;
var sheet = spread.getActiveSheet();
var rowCount = sheet.getRowCount();
var fields = [];
for (var i = 0; i < rowCount; i++) {
var value = sheet.getValue(i, 1);
if (value) {
fields.push({value: value, caption: sheet.getValue(i, 0), width: "*"});
}
}
var view = this.tables[this.selectedTable].addView("selectedTable"+(new Date()).valueOf(), fields);
var mainSpread = this.spread;
mainSpread.clearSheets();
mainSpread.clearSheetTabs();
var sheet = mainSpread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false;
sheet.actionColumn.options({ visible: false });
sheet.setDefaultRowHeight(40, GC.Spread.Sheets.SheetArea.colHeader);
mainSpread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
view.fetch().then(function(args) {
sheet.suspendPaint();
sheet.setDataView(view);
sheet.resumePaint();
});
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/northwind-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/temple-shape.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 500px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 500px;
padding: 3px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.sample-options {
z-index: 1000;
}
.inputContainer {
width: 100%;
height: auto;
border: 1px solid #eee;
padding: 6px 12px;
margin-bottom: 10px;
box-sizing: border-box;
}
.input {
font-size: 14px;
border: 0;
outline: none;
background: transparent;
}
.button {
height: 30px;
padding: 6px 6px;
width: 80px;
margin-top: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);